/*
FileName:UserRoadblock.js
Version:1.0.0
Purpose:Getting the List of all the lsit of roadblock  list 
Devloper:Mahesh Reddy
*/

import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, StatusBar, Dimensions, Image } from 'react-native';
import {  Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import TobeAssigned1 from '../AdminComponets/AdminRoadblocksTobeAssigned';
import Assigned1 from '../AdminComponets/AdminRoadblocksAssigned';

import Icon from 'react-native-vector-icons/FontAwesome';
import {MANAGEROADBLOCKS,TOBEASSIGNED, ASSIGNED} from '../CommonComponents/Header'


export default class AdminRoadblock extends Component {
  render() {
    return (
      
      <Container>
        <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
          <Icon name="bars" size={25} style={{ color: '#fff',}} onPress={() =>
            this.props.navigation.toggleDrawer()} />
          </Left>
          <Body>
            <Title style={{ color: '#fff', fontWeight: '600' }}>{MANAGEROADBLOCKS}</Title>

          </Body>
          {/* <Right>
            <Icon name="home" size={25} style={{ color: '#fff' }}
              onPress={() => this.props.navigation.navigate('UserProfile')} />
          </Right> */}
        </Header>
        

        

        <Tabs tabBarUnderlineStyle={{ borderBottomWidth: 0 }}>
          <Tab heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>{TOBEASSIGNED}</Text></TabHeading>}>
            <TobeAssigned1 navigation={this.props.navigation} />
          </Tab>

          <Tab heading={<TabHeading style={{ backgroundColor: '#00A2C1' }}><Text style={{ color: '#fff' }}>{ASSIGNED}</Text></TabHeading>}>
            <Assigned1 navigation={this.props.navigation} />
          </Tab>
        </Tabs>
      </Container>
    );
  }
}